package org.ucworkbench.model.actor;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Vector;

import org.ucworkbench.model.actor.parser.Node;

/* Generated By:JJTree: Do not edit this line. SimpleNode.java */

public class SimpleNode implements Node {
  protected Node parent;
  protected Node[] children;
  protected int id;
  protected Parser parser;

  public SimpleNode(int i) {
    id = i;
  }

  public SimpleNode(Parser p, int i) {
    this(i);
    parser = p;
  }

  public void jjtOpen() {
  }

  public void jjtClose() {
  }
  
  public void jjtSetParent(Node n) { parent = n; }
  public Node jjtGetParent() { return parent; }

  public void jjtAddChild(Node n, int i) {
    if (children == null) {
      children = new Node[i + 1];
    } else if (i >= children.length) {
      Node c[] = new Node[i + 1];
      System.arraycopy(children, 0, c, 0, children.length);
      children = c;
    }
    children[i] = n;
  }

  public Node jjtGetChild(int i) {
    return children[i];
  }

  public int jjtGetNumChildren() {
    return (children == null) ? 0 : children.length;
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ParserVisitor visitor, Object data) {
    return visitor.visit(this, data);
  }

  /** Accept the visitor. **/
  public Object childrenAccept(ParserVisitor visitor, Object data) {
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        children[i].jjtAccept(visitor, data);
      }
    }
    return data;
  }

  /* You can override these two methods in subclasses of SimpleNode to
     customize the way the node appears when the tree is dumped.  If
     your output uses more than one line you should override
     toString(String), otherwise overriding toString() is probably all
     you need to do. */

	public Node findRoot()
	{
		Node node = this;
		while (node.jjtGetParent() != null)
		{
			node = node.jjtGetParent();
		}

		return node;
	}

	private Token findPointerTo(Token target)
	{
		SimpleNode root = (SimpleNode)findRoot();

		for (Token t = root.begin; t != null; t = t.next)
		{
			if (t.next == target)
			{
				return t;
			}
		}

		return null;
	}


/*
	private SimpleNode findNextNode(SimpleNode node, int start, boolean ignoreEmpty)
	{
		System.out.println("findNextNode " + start + " " + node.toString());
		for (int i = start; i < node.jjtGetNumChildren(); i++)
		{
			System.out.println("Child " + i + ": " + ((SimpleNode)node.jjtGetChild(i)).begin);
			if (!ignoreEmpty || ((SimpleNode)node.jjtGetChild(i)).begin != null)
			{
				System.out.println("Return child " + i);
				return (SimpleNode)(node.jjtGetChild(i));
			}
		}

		// Not found in "node" -- check its parents.

		int myIndex = -1;
		SimpleNode parent = (SimpleNode)node.jjtGetParent();
		if (parent == null)
			return null;

		for (int i = 0; i < parent.jjtGetNumChildren(); i++)
		{
			if (parent.jjtGetChild(i) == node)
			{
				myIndex = i;
				break;
			}
		}

		if (myIndex == -1)
			throw new Error("Coding Error");

		System.out.println("Trying parent at pos " + (myIndex + 1));

		return findNextNode(parent, myIndex + 1, ignoreEmpty);
	}


	private Token findFollowing(SimpleNode node, int index)
	{
		System.out.println("Search node " + VBParserTreeConstants.jjtNodeName[node.id] + " at index " + index);
		for (int i = index + 1; i < node.jjtGetNumChildren(); i++)
		{
			if (((SimpleNode)node.jjtGetChild(i)).begin != null)
			{
				System.out.println("Found at " + i);
				return ((SimpleNode)node.jjtGetChild(i)).begin;
			}
		}

		// Insert at end of this node (or end of the parent of this node...)

		while (node.end == null)
		{
			if (node.jjtGetParent() == null)
				return null;

			System.out.println("node.end == null. Trying " + VBParserTreeConstants.jjtNodeName[((SimpleNode)node.jjtGetParent()).id]);

			node = (SimpleNode)(node.jjtGetParent());
		}

		System.out.println("Setting following to " + node.end.next.sequence + "\"" + node.end.next.image + "\"");

		return node.end.next;
	}
	*/

/*
	private Token findFollowing(SimpleNode node, int index)
	{
		System.out.println("Search node " + VBParserTreeConstants.jjtNodeName[node.id] + " at index " + index);
		for (int i = index + 1; i < node.jjtGetNumChildren(); i++)
		{
			if (((SimpleNode)node.jjtGetChild(i)).begin != null)
				return ((SimpleNode)node.jjtGetChild(i)).begin;
		}

		// Try parent (recursively).

		SimpleNode p = (SimpleNode)(node.jjtGetParent());

		if (p == null)
		{
			// Top-level node.

			return null;
		}

		// What index in the parent's child collection is this node?

		int myIndex = 0;
		for (myIndex = 0; myIndex < p.jjtGetNumChildren(); myIndex++)
		{
			if (p.jjtGetChild(myIndex) == node)
			{
				break;
			}
		}

		return findFollowing(p, myIndex);
	}
*/



  /* You can override these two methods in subclasses of SimpleNode to
     customize the way the node appears when the tree is dumped.  If
     your output uses more than one line you should override
     toString(String), otherwise overriding toString() is probably all
     you need to do. */

  public String toString()
  {
	  StringBuffer buff = new StringBuffer();

	  if (begin != null)
	  {
		buff.append(Integer.toString(begin.beginLine));
		buff.append(" ");
	  }

	  buff.append(ParserTreeConstants.jjtNodeName[id]);
	  buff.append(":  ");
	  if (begin != null)
	  {
	  	buff.append(begin.image);
	  	if (begin.next != null && begin != end) buff.append("...");
      }

	  return buff.toString();
  }

  public String toString(String prefix) { return prefix + toString(); }

  /* Override this method if you want to customize how the node dumps
     out its children. */

	public void dump(PrintStream p, String prefix)
	{
		p.println(toString(prefix));
		if (children != null) {
			for (int i = 0; i < children.length; ++i) {
				SimpleNode n = (SimpleNode)children[i];
				if (n != null) {
					n.dump(p, prefix + "    ");
				}
			}
		}
	}

	public void dump(PrintWriter p, String prefix)
	{
		p.println(toString(prefix));
		if (children != null) {
			for (int i = 0; i < children.length; ++i) {
				SimpleNode n = (SimpleNode)children[i];
				if (n != null) {
					n.dump(p, prefix + "    ");
				}
			}
		}
	}

	public void dump(String prefix)
	{
		dump(System.out, prefix);
	}

	static public String getTokenText(Token t)
	{
		return getTokenText(t, false);
	}

	static public String getTokenText(Token t, boolean includeSpecialText)
	{
		Token tt = t.specialToken;

		if (!includeSpecialText || tt == null)
			return t.image;

		StringBuffer buff = new StringBuffer();

		// Find the start of the special token chain.
		while (tt.specialToken != null)
			tt = tt.specialToken;
		// Now follow the chain forwards, collecting text
		while (tt != null)
		{
			buff.append(tt.image);
			tt = tt.next;
		}

		buff.append(t.image);

		return buff.toString();
	}

	private static final String spaces = "                                                           ";

	public String allText()
	{
		return allText(false);
	}

	public String allText(boolean includeSpecialText)
	{
		Token t = begin;
		StringBuffer buff = new StringBuffer();

		// TODO - this might mean we lose any comment at the end of a file without a \n.
		// Very unlikely...
		while (t != null)
		{
			if (t.kind != ParserConstants.EOF)
				buff.append(getTokenText(t, includeSpecialText));

			if (t == end)
				break;

			t = t.next;
		}

		return buff.toString();
	}

/*
	public String allText(boolean includeSpecialText, int depth) throws ParseException
	{
//		System.out.println(spaces.substring(0, depth*2) +
//			VBParserTreeConstants.jjtNodeName[id] +
//			" " + begin.sequence + " <" + begin.image + "> " + end.sequence + " <" + end.image);

		Token t = begin;
		StringBuffer buff = new StringBuffer();
		int childIndex = 0;

		while (t != null)
		{
			if (children != null && childIndex < children.length)
			{
				SimpleNode child = (SimpleNode)(children[childIndex]);

				// No tokens for this child?

				if (child.begin == null)
				{
					for ( ; childIndex < children.length; childIndex++)
					{
						SimpleNode next = (SimpleNode)(children[childIndex]);
						if (next.begin != child.begin)
							break;
					}

					continue;
				}

				// Have we reached the start of this child's tokens?

				if (child.begin == t)
				{
//					System.out.println(spaces.substring(0, depth*2) + "Call child");
					buff.append(child.allText(includeSpecialText, depth + 1));

					if (child.end == end)
					{
						return buff.toString();
					}

					t = child.end.next;

//					System.out.println(spaces.substring(0, depth*2) + "END of child");

					for ( ; childIndex < children.length; childIndex++)
					{
						SimpleNode next = (SimpleNode)(children[childIndex]);
						if (next.begin != child.begin)
							break;
					}

//					System.out.println(spaces.substring(0, depth*2) + "Next Child " + childIndex);
					if (childIndex < children.length)
					{
						child = (SimpleNode)(children[childIndex]);
//						System.out.println(spaces.substring(0, depth*2) + "           " +
//							VBParserTreeConstants.jjtNodeName[child.id] +
//							" " + child.begin.sequence + " <" + child.begin.image + "> " + child.end.sequence + " <" + child.end.image);
					}
					else
					{
//						System.out.println(spaces.substring(0, depth*2) + "           " + "No more children");
					}

					continue;
				}
			}

			buff.append(getTokenText(t, includeSpecialText));
//			System.out.println(spaces.substring(0, depth*2) + "Appended <" + getTokenText(t, false) + ">");

			if (t == end)
			{
//				System.out.println(spaces.substring(0, depth*2) + "END of this node at " + t.sequence + " " + t.image);
				break;
			}

			t = t.next;
		}

//		System.out.println(spaces.substring(0, depth*2) + "return " + VBParserTreeConstants.jjtNodeName[id] + ": <" + buff.toString() + ">");
		return buff.toString();
	}
*/

	public SimpleNode findNode(int nodeId)
	{
		return findNode(nodeId, null);
	}

	public SimpleNode findNode(int nodeId, String name)
	{
		SimpleNode ret;

		if ((nodeId == id) && (name == null || (begin != null && name.equalsIgnoreCase(begin.image))))
			return this;

		if (children == null)
			return null;

		for (int i = 0; i < children.length; i++)
		{
			SimpleNode n = (SimpleNode)(children[i]);
			ret = n.findNode(nodeId, name);

			if (ret != null)
				return ret;
		}

		return null;
	}

	public SimpleNode[] findNodes(int nodeId)
	{
		return findNodes(nodeId, null);
	}

	public SimpleNode[] findNodes(int nodeId, String name)
	{
		Vector v = new Vector();
		findNodes(nodeId, name, v);
		return (SimpleNode[])v.toArray(new SimpleNode[v.size()]);
	}

	public void findNodes(int nodeId, String name, Vector v)
	{
		//System.out.println("Node Id " + id + " (target " + nodeId + ")");

		if ((nodeId == id) && (name == null || (begin != null && name.equalsIgnoreCase(begin.image))))
			v.add(this);

		if (children == null)
			return;

		for (int i = 0; i < children.length; i++)
		{
			SimpleNode n = (SimpleNode)(children[i]);
			n.findNodes(nodeId, name, v);
		}
	}


	/*
	**	Each SimpleNode has a range of tokens (the 'begin' and 'end' variables).
	**	However parent / child nodes do not always have the ranges that would be
	**	expected. For example a child node may have a range that starts before
	**	the parent's range (e.g. for BinOp productions:
			void ImpExpression() :
			{}
			{
				EqvExpression()
				(
					( <IMP> { jjtThis.op = getToken(0).image; } EqvExpression() ) #BinOp(2)
				)*
			}
	**	We therefore need a convenient way to determine token ranges, and in particular, we
	**	need an efficient method to determine if one token is ealier in the chain than another.
	**	To do this we look at the tokens' sequence numbers.
	**
	**	This method is provided as tokens may be inserted or deleted from the token chain,
	*/
	public void renumberTokens()
	{
		SimpleNode n = this;
		while (n.jjtGetParent() != null)
			n = (SimpleNode)n.jjtGetParent();

		int seq = 1;
		for (Token t = n.begin; t != null; t = t.next)
			t.sequence = seq++;

//		System.out.println("Renumber debug:");
//		for (Token t = n.begin; t != null; t = t.next)
//			System.out.println(t.debug());
	}

	public TokenRange getTokenRange()
	{
		TokenRange r = new TokenRange();

		recurseTokenRange(this, r);

		return r;
	}

	private void recurseTokenRange(SimpleNode n, TokenRange r)
	{
		if (r.begin == null)
			r.begin = n.begin;
		else if (n.begin != null && n.begin.sequence < r.begin.sequence)
			r.begin = n.begin;

		if (r.end == null)
			r.end = n.end;
		else if (n.end != null && n.end.sequence > r.end.sequence)
			r.end = n.end;

		if (n.children != null)
		{
			for (int i = 0; i < n.children.length; i++)
			{
				SimpleNode child = (SimpleNode)n.children[i];

				recurseTokenRange(child, r);
			}
		}
	}



  protected Token begin, end;

  public void setFirstToken(Token t) { begin = t;}
  public void setLastToken(Token t) { end = t;}

  public Token getFirstToken() { return begin;}
  public Token getLastToken() { return end;}

  public ParseException parseException = null;

  protected String name;
  public String getName()
  {
	  return name;
  }
  public void setName(String name)
  {
	  this.name = name;
  }

  public void process(PrintWriter ostr)
  {
  }

  protected void print(Token t, PrintWriter ostr)
  {
	  Token tt = t.specialToken;

	  if (tt != null)
	  {
		  while (tt.specialToken != null) tt = tt.specialToken;

		  while (tt != null) {
			  ostr.print(tt.image);
			  tt = tt.next;
		  }
	  }

	  ostr.print(t.image);
  }

  private static class TokenRange
  {
	  public TokenRange()
	  {
	  }

	  public TokenRange(Token begin, Token end)
	  {
		  this.begin = begin;
		  this.end = end;
	  }

	  private Token begin;
	  private Token end;

	  public String debug()
	  {
		  if (begin == null)
		  {
			  return "TokenRange: start <null> end " + (end == null ? "<null>" : end.debug());
		  }
		  else
		  {
			  StringBuffer sb = new StringBuffer();
			  sb.append("TokenRange:");
			  for (Token t = begin; ; t = t.next)
			  {
				  sb.append(t.debug());
				  if (t == end)
				  	break;
			  }
			  return new String(sb);
		  }
	  }
  }}

